PROGRAM estremi
!Calcola massimo e minimo di un insieme 
! e visua1izza i dati segna1ando il massimo
! e il minimo con apposite etichette.
!AUTORE: Giuseppe Ciaburro

IMPLICIT NONE

! Lista dei parametri:
INTEGER, PARAMETER :: max_size = 10  ! Dimensione massima dell'insieme dei dati

!Lista delle variabili:
INTEGER, DIMENSION(max_size) :: input ! Valori di input
INTEGER :: imax             ! Puntatore al valore
INTEGER :: imin             ! Puntatore al valore
INTEGER :: j                ! Indice del ciclo 00
INTEGER :: nvals            ! Numero di valori dell'insieme 
INTEGER :: temp             ! Variabile temporanea

!Acquisisce il numero dei valori dell'insieme
WRITE (*,*) "Digita il numero di valori dell'insieme:"
READ  (*,*) nvals
!Numero <= max_size ?
size: IF ( nvals <= max_size ) THEN
! Acquisisce i valori di input
      in: DO j = 1, nvals
          WRITE (*,100) 'Digita il valore' ,j
          100 FORMAT (' ',A,I3,': ')
          READ(*,*) input(j)
      END DO in
! Trova il massimo
      temp = input(1)
      imax = 1
      large: DO j = 2, nvals
             IF ( input(j) > temp ) THEN
                 temp = input(j)
                 imax = j
             END IF
      END DO large
! Trova il minimo
      temp = input(1)
      imin = 1
      small: DO j = 2, nvals
             IF ( input(j) < temp ) THEN
                 temp = input(j)
                 imin = j
             END IF
      END DO small
! Visualizza i valori
      WRITE (*,110)
      110 FORMAT ('0','I valori sono: ')

      out: DO j = 1, nvals
           IF ( j == imax ) THEN
               WRITE (*,'(1X,I6,2X,A)') input(j), 'MASSIMO' 
           ELSE IF ( j == imin ) THEN
               WRITE (*,'(1X,I6,2X,A)') input(j), 'MINIMO' 
           ELSE
               WRITE (*, ' (1X,I6) ') input(j)
           END IF
      END DO out
ELSE size
! nvals > max size. Informa l'utente e termina.
      WRITE (*,120) nvals, max_size
      120 FORMAT (1X,'Troppi valori di input: ', I6, ' > ' , I6) 
END IF size
END PROGRAM



